
<h3 *ngIf="!editMode" class="card-title">Add user using reactive form validation</h3>
<h3 *ngIf="editMode" class="card-title">Edit user</h3>

<div *ngIf="userDoNotExist" class="warning">
    This user no longer exist.
</div>

<button routerLink="/" class="btn btn-secondary">Back</button>

<form [formGroup]="userForm" (ngSubmit)="onSubmit()">
    <div class="form-group">
        <label>Username</label>
        <input type="text" name="username" class="form-control" formControlName="name">
        <div *ngIf="userForm.get('name')?.touched && userForm.get('name')?.hasError('required')" class="form-error">
            This username is not available
        </div>
    </div>
    <div class="form-group">
        <label>Email</label>
        <input type="email" name="email" class="form-control" formControlName="email">
        <div *ngIf="userForm.get('email')?.touched && userForm.get('email')?.invalid" class="form-error">
            This is not correct email
        </div>
    </div>
    <div *ngIf="!editMode" class="form-group" formGroupName="passwordGroup">
        <div class="form-group">
            <label>Password</label>
            <my-password-input name="password" class="form-control" formControlName="password1" [canShowPassword]="false" ></my-password-input>
            <div *ngIf="userForm.get('passwordGroup')?.get('password1')?.touched && userForm.get('passwordGroup')?.get('password1')?.invalid" class="form-error">
                Password should have at least 8 characters including one uppercase, one lowercase and one number
            </div>
        </div>
        <div class="form-group">
            <label>Repeat Password</label>
            <my-password-input name="password_match" class="form-control" formControlName="password2"></my-password-input>
            <div *ngIf="userForm.get('passwordGroup')?.get('password1')?.touched && userForm.get('passwordGroup')?.get('password2')?.touched && userForm.get('passwordGroup')?.get('password2')?.invalid" class="form-error">
                <p *ngIf="userForm.get('passwordGroup')?.get('password1')?.valid && userForm.get('passwordGroup')?.get('password2')?.hasError('noMatch')">Passwords should match.</p>
                <p *ngIf="userForm.get('passwordGroup')?.get('password2')?.hasError('required')">Passwords should be confirm.</p>
            </div>
        </div>
    </div>
    <div class="form-group">
        <label>Phone Number</label>
        <input class="form-control" name="phoneNumber" type="tel" formControlName="phone">
        <div *ngIf="userForm.get('phone')?.touched && userForm.get('phone')?.invalid" class="form-error">
            This phone number is invalid. Valid format is (999) 999-9999
        </div>
    </div>
    <div class="form-group">
        <label>Country</label>
        <select *ngIf="countriesData" class="form-control" name="country" formControlName="country"  (change)="changeCountry()">
            <option value="">--Select Country--</option>
            <option *ngFor="let item of countriesData" [value]="item.id">{{ item.name }}</option>
        </select>
        <div *ngIf="!countriesData" class="form-error">
            Countries are unavailables.
        </div>
        <div *ngIf="countriesData && !userForm.get('country')?.value" class="form-error">
            Please select a country.
        </div>
    </div>
    <div class="form-group">
        <label>State</label>
        <select *ngIf="statesData" class="form-control" name="state" formControlName="state">
            <option value="">--Select State--</option>
            <option *ngFor="let item of statesData" [value]="item.id">{{ item.name }}</option>
        </select>
        <div *ngIf="!statesData" class="form-error">
            States are unavailables.
        </div>
        <div *ngIf="statesData && !userForm.get('state')?.value" class="form-error">
            This state is not valid, please select a state.
        </div>
    </div>
    <div class="form-group">
        <button [disabled]="!userForm.valid" type="submit" class="btn btn-primary ">{{ submitText }}</button>
    </div>
</form>
